//+------------------------------------------------------------------+ 
//|Validator v2.mq4 
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, 2008, DGC"
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1 ForestGreen
#property  indicator_width1 2
#property  indicator_color2 Crimson
#property  indicator_width2 2

extern int iPeriod = 80; 

double BuffLong[];
double BuffShort[];
double Buff0[];

int init()
  {
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, BuffLong);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, BuffShort);
   SetIndexBuffer(2, Buff0);
   IndicatorShortName("Swing Validator v2 ("+iPeriod+")");
   return(0);
  }

int start()
   {
   int limit;
   int counted_bars = IndicatorCounted();
   if (counted_bars > 0) counted_bars --;
   limit = Bars - counted_bars;
   for(int i = 0; i < limit; i ++)
      {
      Buff0[i] = iCustom(NULL, 0, "SwingLine", iPeriod / 4, 0, i) - iCustom(NULL, 0, "SwingLine", iPeriod, 0, i);
      if (Buff0[i] > 0)
         {
         BuffLong[i] = MathAbs(Buff0[i]);
         BuffShort[i] = EMPTY_VALUE;
         }
      if (Buff0[i] <= 0)
         {
         BuffLong[i] = EMPTY_VALUE;
         BuffShort[i] = MathAbs(Buff0[i]);
         }
      }      
   return(0);
   }

